-- example :
-- walk_current_track_all_notes (transpose_note,9)
-- walk_current_track_all_notes (change_notes_with_strings,
--         {["C-3"]="G-3",["C-4"]="G-4"})

local notes_table = {}


renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:note_change_functions_test...",
  invoke = function() 
    test_main()
  end
 }


function change_notes_with_strings
  (renoise_NoteColumn_object,note_change_table)
  local note_string_before = 
      renoise_NoteColumn_object.note_string
  if note_change_table[note_string_before] == nil
   then return nil
  else
    renoise_NoteColumn_object.note_string
  = note_change_table[note_string_before]
  end
end



function transpose_note
  (renoise_NoteColumn_object,transpose_value)

local note_num = renoise_NoteColumn_object.note_value

    if  (note_num < 120)
  and
  ((note_num + transpose_value) >= 0)
  and
  ((note_num + transpose_value) < 120)
    then
  renoise_NoteColumn_object.note_value
  = (note_num + transpose_value)
  
    else
      return nil
  end
end




function walk_current_track_notes
  (line_from,line_to,column_from,column_to,change_func,...)
  local li_max = renoise.song().selected_pattern.number_of_lines
  local  co_max = renoise.song().selected_track.visible_note_columns
  if
    line_from <= line_to
    and
    line_from >= 1
    and
    column_from <= column_to
    and
    column_from >= 1
    and
    line_to <= li_max
    and
    column_to <= co_max
  then
  
    for li = line_from,line_to do
      for co = column_from,column_to do
      
     local nc_obj = renoise.song().selected_pattern_track.lines[li].note_columns[co]
     change_func (nc_obj,...)
      end
    end
  else return nil
  end
end
  


function walk_current_track_all_notes (change_func,...)
  local li_max = renoise.song().selected_pattern.number_of_lines
  local  co_max = renoise.song().selected_track.visible_note_columns
  for li = 1,li_max do
    for co = 1,co_max do
      local nc_obj =
	renoise.song().selected_pattern_track.lines[li].note_columns[co]
      change_func(nc_obj,...)
    end
  end
end



function save_a_note_to_table (line_index,column_index,table)
  local tbl = {}
        tbl [line_index] = {}
  tbl[line_index][column_index] =
    renoise.song().selected_pattern_track
    .lines[line_index].note_columns[column_index]
    .note_value
  if
    type(table[line_index]) ~= "table"
           then
    table[line_index] = {}
    table[line_index][column_index] =
    tbl[line_index][column_index]
  else
    table[line_index][column_index] =
    tbl[line_index][column_index]
  end
  return table
end


function save_current_track_notes_to_table
  (line_from,line_to,column_from,column_to,table)
  local li_max = renoise.song().selected_pattern.number_of_lines
  local  co_max = renoise.song().selected_track.visible_note_columns
  if
    line_from <= line_to
    and
    line_from >= 1
    and
    column_from <= column_to
    and
    column_from >= 1
    and
    line_to <= li_max
    and
    column_to <= co_max
  then
  
    for li = line_from,line_to do
      for co = column_from,column_to do
         save_a_note_to_table (li,co,table)
      end
    end
  else return nil
  end
  return table
end


function save_all_current_track_notes_to_table (table)
 local li_max = renoise.song().selected_pattern.number_of_lines
 local  co_max = renoise.song().selected_track.visible_note_columns

  save_current_track_notes_to_table(1,li_max,1,co_max,table)
  return table
end


function write_notes_from_table (table)
  for li,co_tbl in pairs(table) do
    for co,no_num in pairs(co_tbl) do
      renoise.song().selected_pattern_track
    .lines[li].note_columns[co]
    .note_value = no_num
     end
    end
end



function see_notes_table (table)
   for li,co_tbl in pairs(table) do
     for co,no_num in pairs(co_tbl) do
    print("line"..li..",column"..co..":"..no_num.." ")
     end
   end
end

function test_main ()
local vb = renoise.ViewBuilder()
local copy_selected_track = renoise.song().selected_track
 

local dialog_content = 
    vb:column {
  vb:button {
        width = 80,
        text = "+7",
        notifier =
          function()
                walk_current_track_all_notes (transpose_note,7)
          end
  }
  ,
  vb:button {
        width = 80,
        text = "-7",
        notifier =
    function()
                walk_current_track_all_notes (transpose_note,-7)
          end
  },
  vb:button {
        width = 80,
        text = "save",
        notifier =
          function()
               save_all_current_track_notes_to_table (notes_table)
          end
  },
  vb:button {
        width = 80,
        text = "reset",
        notifier =
          function()
                write_notes_from_table (notes_table)
          end
  }
    }
 renoise.app():show_custom_dialog("test +-7" , dialog_content)
end



